# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesSiteRecovery::Mgmt::V2016_08_10
  module Models
    #
    # Contains the localized display information for this particular operation
    # / action. These value will be used by several clients for (1) custom role
    # definitions for RBAC; (2) complex query filters for the event service;
    # and (3) audit history / records for management operations.
    #
    class Display

      include MsRestAzure

      # @return [String] The provider. The localized friendly form of the
      # resource provider name – it is expected to also include the
      # publisher/company responsible. It should use Title Casing and begin
      # with "Microsoft" for 1st party services. e.g. "Microsoft Monitoring
      # Insights" or "Microsoft Compute."
      attr_accessor :provider

      # @return [String] The resource. The localized friendly form of the
      # resource related to this action/operation – it should match the public
      # documentation for the resource provider. It should use Title Casing.
      # This value should be unique for a particular URL type (e.g. nested
      # types should *not* reuse their parent’s display.resource field). e.g.
      # "Virtual Machines" or "Scheduler Job Collections", or "Virtual Machine
      # VM Sizes" or "Scheduler Jobs"
      attr_accessor :resource

      # @return [String] The operation. The localized friendly name for the
      # operation, as it should be shown to the user. It should be concise (to
      # fit in drop downs) but clear (i.e. self-documenting). It should use
      # Title Casing. Prescriptive guidance: Read Create or Update Delete
      # 'ActionName'
      attr_accessor :operation

      # @return [String] The description. The localized friendly description
      # for the operation, as it should be shown to the user. It should be
      # thorough, yet concise – it will be used in tool tips and detailed
      # views. Prescriptive guidance for namespaces: Read any
      # 'display.provider' resource Create or Update any 'display.provider'
      # resource Delete any 'display.provider' resource Perform any other
      # action on any 'display.provider' resource Prescriptive guidance for
      # namespaces: Read any 'display.resource' Create or Update any
      # 'display.resource' Delete any 'display.resource' 'ActionName' any
      # 'display.resources'
      attr_accessor :description


      #
      # Mapper for Display class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Display',
          type: {
            name: 'Composite',
            class_name: 'Display',
            model_properties: {
              provider: {
                client_side_validation: true,
                required: false,
                serialized_name: 'provider',
                type: {
                  name: 'String'
                }
              },
              resource: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resource',
                type: {
                  name: 'String'
                }
              },
              operation: {
                client_side_validation: true,
                required: false,
                serialized_name: 'operation',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
