# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesSiteRecovery::Mgmt::V2016_08_10
  module Models
    #
    # List of network mappings. As with NetworkMapping, it should be possible
    # to reuse a prev version of this class. It doesn't seem likely this class
    # could be anything more than a slightly bespoke collection of
    # NetworkMapping. Hence it makes sense to override Load with
    # Base.NetworkMapping instead of existing CurrentVersion.NetworkMapping.
    #
    class NetworkMappingCollection

      include MsRestAzure

      include MsRest::JSONable
      # @return [Array<NetworkMapping>] The Network Mappings list.
      attr_accessor :value

      # @return [String] The value of next link.
      attr_accessor :next_link

      # return [Proc] with next page method call.
      attr_accessor :next_method

      #
      # Gets the rest of the items for the request, enabling auto-pagination.
      #
      # @return [Array<NetworkMapping>] operation results.
      #
      def get_all_items
        items = @value
        page = self
        while page.next_link != nil && !page.next_link.strip.empty? do
          page = page.get_next_page
          items.concat(page.value)
        end
        items
      end

      #
      # Gets the next page of results.
      #
      # @return [NetworkMappingCollection] with next page content.
      #
      def get_next_page
        response = @next_method.call(@next_link).value! unless @next_method.nil?
        unless response.nil?
          @next_link = response.body.next_link
          @value = response.body.value
          self
        end
      end

      #
      # Mapper for NetworkMappingCollection class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'NetworkMappingCollection',
          type: {
            name: 'Composite',
            class_name: 'NetworkMappingCollection',
            model_properties: {
              value: {
                client_side_validation: true,
                required: false,
                serialized_name: 'value',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'NetworkMappingElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'NetworkMapping'
                      }
                  }
                }
              },
              next_link: {
                client_side_validation: true,
                required: false,
                serialized_name: 'nextLink',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
