# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesSiteRecovery::Mgmt::V2018_01_10
  module Models
    #
    # Details of a Master Target Server.
    #
    class MasterTargetServer

      include MsRestAzure

      # @return [String] The server Id.
      attr_accessor :id

      # @return [String] The IP address of the server.
      attr_accessor :ip_address

      # @return [String] The server name.
      attr_accessor :name

      # @return [String] The OS type of the server.
      attr_accessor :os_type

      # @return [String] The version of the scout component on the server.
      attr_accessor :agent_version

      # @return [DateTime] The last heartbeat received from the server.
      attr_accessor :last_heartbeat

      # @return [String] Version status
      attr_accessor :version_status

      # @return [Array<RetentionVolume>] The retention volumes of Master target
      # Server.
      attr_accessor :retention_volumes

      # @return [Array<DataStore>] The list of data stores in the fabric.
      attr_accessor :data_stores

      # @return [Array<HealthError>] Validation errors.
      attr_accessor :validation_errors

      # @return [Array<HealthError>] Health errors.
      attr_accessor :health_errors

      # @return [Integer] Disk count of the master target.
      attr_accessor :disk_count

      # @return [String] OS Version of the master target.
      attr_accessor :os_version

      # @return [DateTime] Agent expiry date.
      attr_accessor :agent_expiry_date

      # @return [String] MARS agent version.
      attr_accessor :mars_agent_version

      # @return [DateTime] MARS agent expiry date.
      attr_accessor :mars_agent_expiry_date

      # @return [VersionDetails] Agent version details.
      attr_accessor :agent_version_details

      # @return [VersionDetails] Mars agent version details.
      attr_accessor :mars_agent_version_details


      #
      # Mapper for MasterTargetServer class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'MasterTargetServer',
          type: {
            name: 'Composite',
            class_name: 'MasterTargetServer',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              ip_address: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ipAddress',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              os_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'osType',
                type: {
                  name: 'String'
                }
              },
              agent_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'agentVersion',
                type: {
                  name: 'String'
                }
              },
              last_heartbeat: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastHeartbeat',
                type: {
                  name: 'DateTime'
                }
              },
              version_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'versionStatus',
                type: {
                  name: 'String'
                }
              },
              retention_volumes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'retentionVolumes',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'RetentionVolumeElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'RetentionVolume'
                      }
                  }
                }
              },
              data_stores: {
                client_side_validation: true,
                required: false,
                serialized_name: 'dataStores',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DataStoreElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'DataStore'
                      }
                  }
                }
              },
              validation_errors: {
                client_side_validation: true,
                required: false,
                serialized_name: 'validationErrors',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'HealthErrorElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'HealthError'
                      }
                  }
                }
              },
              health_errors: {
                client_side_validation: true,
                required: false,
                serialized_name: 'healthErrors',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'HealthErrorElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'HealthError'
                      }
                  }
                }
              },
              disk_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'diskCount',
                type: {
                  name: 'Number'
                }
              },
              os_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'osVersion',
                type: {
                  name: 'String'
                }
              },
              agent_expiry_date: {
                client_side_validation: true,
                required: false,
                serialized_name: 'agentExpiryDate',
                type: {
                  name: 'DateTime'
                }
              },
              mars_agent_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'marsAgentVersion',
                type: {
                  name: 'String'
                }
              },
              mars_agent_expiry_date: {
                client_side_validation: true,
                required: false,
                serialized_name: 'marsAgentExpiryDate',
                type: {
                  name: 'DateTime'
                }
              },
              agent_version_details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'agentVersionDetails',
                type: {
                  name: 'Composite',
                  class_name: 'VersionDetails'
                }
              },
              mars_agent_version_details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'marsAgentVersionDetails',
                type: {
                  name: 'Composite',
                  class_name: 'VersionDetails'
                }
              }
            }
          }
        }
      end
    end
  end
end
