# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesSiteRecovery::Mgmt::V2018_01_10
  module Models
    #
    # Represents applicable recovery vm sizes properties.
    #
    class TargetComputeSizeProperties

      include MsRestAzure

      # @return [String] Target compute size name.
      attr_accessor :name

      # @return [String] Target compute size display name.
      attr_accessor :friendly_name

      # @return [Integer] The maximum cpu cores count supported by target
      # compute size.
      attr_accessor :cpu_cores_count

      # @return [Float] The maximum memory in GB supported by target compute
      # size.
      attr_accessor :memory_in_gb

      # @return [Integer] The maximum data disks count supported by target
      # compute size.
      attr_accessor :max_data_disk_count

      # @return [Integer] The maximum Nics count supported by target compute
      # size.
      attr_accessor :max_nics_count

      # @return [Array<ComputeSizeErrorDetails>] The reasons why the target
      # compute size is not applicable for the protected item.
      attr_accessor :errors

      # @return [String] The value indicating whether the target compute size
      # supports high Iops.
      attr_accessor :high_iops_supported


      #
      # Mapper for TargetComputeSizeProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'TargetComputeSizeProperties',
          type: {
            name: 'Composite',
            class_name: 'TargetComputeSizeProperties',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'friendlyName',
                type: {
                  name: 'String'
                }
              },
              cpu_cores_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'cpuCoresCount',
                type: {
                  name: 'Number'
                }
              },
              memory_in_gb: {
                client_side_validation: true,
                required: false,
                serialized_name: 'memoryInGB',
                type: {
                  name: 'Double'
                }
              },
              max_data_disk_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'maxDataDiskCount',
                type: {
                  name: 'Number'
                }
              },
              max_nics_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'maxNicsCount',
                type: {
                  name: 'Number'
                }
              },
              errors: {
                client_side_validation: true,
                required: false,
                serialized_name: 'errors',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ComputeSizeErrorDetailsElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ComputeSizeErrorDetails'
                      }
                  }
                }
              },
              high_iops_supported: {
                client_side_validation: true,
                required: false,
                serialized_name: 'highIopsSupported',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
