# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesSiteRecovery::Mgmt::V2018_01_10
  module Models
    #
    # VMM fabric provider specific VM settings.
    #
    class VmmVirtualMachineDetails < ConfigurationSettings

      include MsRestAzure


      def initialize
        @instanceType = "VmmVirtualMachine"
      end

      attr_accessor :instanceType

      # @return [String] The source id of the object.
      attr_accessor :source_item_id

      # @return [String] The id of the object in fabric.
      attr_accessor :generation

      # @return [OSDetails] The Last replication time.
      attr_accessor :os_details

      # @return [Array<DiskDetails>] The Last successful failover time.
      attr_accessor :disk_details

      # @return [PresenceStatus] A value indicating whether the VM has a
      # physical disk attached. String value of
      # {SrsDataContract.PresenceStatus} enum. Possible values include:
      # 'Unknown', 'Present', 'NotPresent'
      attr_accessor :has_physical_disk

      # @return [PresenceStatus] A value indicating whether the VM has a fibre
      # channel adapter attached. String value of
      # {SrsDataContract.PresenceStatus} enum. Possible values include:
      # 'Unknown', 'Present', 'NotPresent'
      attr_accessor :has_fibre_channel_adapter

      # @return [PresenceStatus] A value indicating whether the VM has a shared
      # VHD attached. String value of {SrsDataContract.PresenceStatus} enum.
      # Possible values include: 'Unknown', 'Present', 'NotPresent'
      attr_accessor :has_shared_vhd


      #
      # Mapper for VmmVirtualMachineDetails class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'VmmVirtualMachine',
          type: {
            name: 'Composite',
            class_name: 'VmmVirtualMachineDetails',
            model_properties: {
              instanceType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'instanceType',
                type: {
                  name: 'String'
                }
              },
              source_item_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sourceItemId',
                type: {
                  name: 'String'
                }
              },
              generation: {
                client_side_validation: true,
                required: false,
                serialized_name: 'generation',
                type: {
                  name: 'String'
                }
              },
              os_details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'osDetails',
                type: {
                  name: 'Composite',
                  class_name: 'OSDetails'
                }
              },
              disk_details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'diskDetails',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DiskDetailsElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'DiskDetails'
                      }
                  }
                }
              },
              has_physical_disk: {
                client_side_validation: true,
                required: false,
                serialized_name: 'hasPhysicalDisk',
                type: {
                  name: 'String'
                }
              },
              has_fibre_channel_adapter: {
                client_side_validation: true,
                required: false,
                serialized_name: 'hasFibreChannelAdapter',
                type: {
                  name: 'String'
                }
              },
              has_shared_vhd: {
                client_side_validation: true,
                required: false,
                serialized_name: 'hasSharedVhd',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
